<?php

namespace Teknisa\CUS\Modules\Parametros\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;


class Cus00500ParametrosDeCustos extends \Teknisa\GER\Controllers\TeknisaCrud {
	protected $crudService;
	protected $dataSourceName;
	protected $parameterBagColumns = array();
	protected $environment;
	protected $connection;
	protected $newCode;
	protected $dataSourceManager;
	
	public function __construct($crudService, $parameterBagColumns, $environment, $connection, $newCode, $dataSourceManager) {
		$this->crudService = $crudService;
		$this->parameterBagColumns = $parameterBagColumns;
		$this->environment = $environment;
		$this->connection = $connection;
		$this->newCode = $newCode;
		$this->dataSourceManager = $dataSourceManager;
	}
	
	public function updateTabbedGeral(DTO\Request\Row $request, DTO\Response $response) {
	    $row = $request->getRow();
        $sql = "UPDATE PARAMGERAL
                SET
                  CDTPINDICE = :CDTPINDICE,
                  IDPERVALOR = :IDPERVALOR,
                  CDINDICEMF = :CDINDICEMF,
                  QTBLOQNESTOP = :QTBLOQNESTOP,
                  QTLIBENESTOR = :QTLIBENESTOR,
                  VRPECURVAA = :VRPECURVAA,
                  VRPECURVAB = :VRPECURVAB,
                  VRPECURVAC = :VRPECURVAC,
                  CDINDICEMF2 = :CDINDICEMF2,
                  CDTPINDICE2 = :CDTPINDICE2,
                  IDPERVALOR2 = :IDPERVALOR2
                WHERE
                  CDPARGERAL = :OLD_CDPARGERAL";
        
        $params = array(
            "CDTPINDICE"     => $row["CDTPINDICE"],
            "IDPERVALOR"     => $row["IDPERVALOR"],
            "CDINDICEMF"     => $row["CDINDICEMF"],
            "QTBLOQNESTOP"   => $row["QTBLOQNESTOP"],
            "QTLIBENESTOR"   => $row["QTLIBENESTOR"],
            "VRPECURVAA"     => $row["VRPECURVAA"],
            "VRPECURVAB"     => $row["VRPECURVAB"],
            "VRPECURVAC"     => $row["VRPECURVAC"],
            "CDINDICEMF2"    => $row["CDINDICEMF2"],
            "CDTPINDICE2"    => $row["CDTPINDICE2"],
            "IDPERVALOR2"    => $row["IDPERVALOR2"],
            "OLD_CDPARGERAL" => $row["CDPARGERAL"]
        );
        
        try {
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
	
	public function updateTabbedFilial(DTO\Request\Row $request, DTO\Response $response) {
	    $row = $request->getRow();
        $sql = "UPDATE PARAMFILIAL
                SET
                  IDCOMCUSPERC = :IDCOMCUSPERC,
                  VRDIFCUSTACAO = :VRDIFCUSTACAO
                WHERE
                  CDFILIAL = :CDFILIAL";
        
        $params = array(
            "CDFILIAL"      => $row['CDFILIAL'],
            "IDCOMCUSPERC"  => $row['IDCOMCUSPERC'],
            "VRDIFCUSTACAO" => floatval($row['VRDIFCUSTACAO'])
        );
        
        try {
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function updateTipoCusto(DTO\Request\Row $request, DTO\Response $response) {
	    $row = $request->getRow();
        $sql = "UPDATE TIPOCUSTO
                SET
                  IDUTTPCUSTO = :IDUTTPCUSTO
                WHERE
                  CDTIPOCUSTO = :CDTIPOCUSTO";
        
        $params = array(
            "IDUTTPCUSTO" => $row['IDUTTPCUSTO'],
            "CDTIPOCUSTO" => $row['CDTIPOCUSTO']
        );
        
        try {
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
}